SG3 = LibStub("AceAddon-3.0"):NewAddon("SG3", "AceHook-3.0", "AceTimer-3.0")

-- Gloves of Ambivalence in Legion

local SG3AlreadyCalled = false
local EquippedGlovesID = 1
local SG3Disabled = true
local SG3Mining = false
local SG3Skinning = false
local SG3Herbalism = false
local SG3HasGloves = false
local SG3Archaelogy = false
local SG3ArchaelogySurveyString = ""
local DebugSkinningCombatTimer3Set = false

SG3DebugString = "Empty"

-- ~ Initial Release
local SG3frame = CreateFrame("FRAME");
SG3frame:RegisterEvent("PLAYER_LOGOUT");
SG3frame:RegisterEvent("ADDON_LOADED");

function SG3frame:OnEvent(event, arg)
  if event == "ADDON_LOADED" and arg == "StickyGloves" then
    print("StickyGloves loaded: Legion")
    if SG3FirstRun == nil then
      SG3FirstRun = true;
    end
  elseif event == "PLAYER_LOGOUT" then
    SG3FirstRun = false;
  end
end

SG3frame:SetScript("OnEvent", SG3frame.OnEvent);

function SG3:OnEnable()
  self:ScheduleTimer("WelcomeTimer", 3)
end

-- Local Translations for Objects not available through internal lookups

-- Legion Herbs
function SG3:GetStarlightRoseHerbString()
  if (GetLocale() == "enUS") then
    return("Starlight Rose")
  else
    return("Starlight Rose")
  end
end
function SG3:GetAethrilHerbString()
  if (GetLocale() == "enUS") then
    return("Aethril")
  else
    return("Aethril")
  end
end
function SG3:GetDreamleafHerbString()
  if (GetLocale() == "enUS") then
    return("Dreamleaf")
  else
    return("Dreamleaf")
  end
end
function SG3:GetFjarnskagglHerbString()
  if (GetLocale() == "enUS") then
    return("Fjarnskaggl")
  else
    return("Fjarnskaggl")
  end
end
function SG3:GetFoxflowerHerbString()
  if (GetLocale() == "enUS") then
    return("Foxflower")
  else
    return("Foxflower")
  end
end
function SG3:GetFelEncrustedHerbHerbString()
  if (GetLocale() == "enUS") then
    return("Fel-Encrusted Herb")
  else
    return("Fel-Encrusted Herb")
  end
end
function SG3:GetAstralGloryHerbString()
  if (GetLocale() == "enUS") then
    return("Astral Glory")
  else
    return("Astral Glory")
  end
end
function SG3:GetFelwortHerbString()
  if (GetLocale() == "enUS") then
    return("Felwort")
  else
    return("Felwort")
  end
end

-- Legion mining nodes
function SG3:GetFelslateDepositString()
  if (GetLocale() == "enUS") then
    return("Felslate Deposit")
  else
    return("Felslate Deposit")
  end
end
function SG3:GetFelslateSeamString()
  if (GetLocale() == "enUS") then
    return("Felslate Seam")
  else
    return("Felslate Seam")
  end
end
function SG3:GetInfernalBrimstoneString()
  if (GetLocale() == "enUS") then
    return("Infernal Brimstone")
  else
    return("Infernal Brimstone")
  end
end
function SG3:GetLeystoneDepositString()
  if (GetLocale() == "enUS") then
    return("Leystone Deposit")
  else
    return("Leystone Deposit")
  end
end
function SG3:GetLeystoneSeamString()
  if (GetLocale() == "enUS") then
    return("Leystone Seam")
  else
    return("Leystone Seam")
  end
end
function SG3:GetLivingFelslateString()
  if (GetLocale() == "enUS") then
    return("Living Felslate")
  else
    return("Living Felslate")
  end
end
function SG3:GetLivingLeystoneString()
  if (GetLocale() == "enUS") then
    return("Living Leystone")
  else
    return("Living Leystone")
  end
end
function SG3:GetEmpyriumDepositString()
  if (GetLocale() == "enUS") then
    return("Living Empyrium Deposit")
  else
    return("Living Empyrium Deposit")
  end
end
function SG3:GetEmpyriumSeamString()
  if (GetLocale() == "enUS") then
    return("Living Empyrium Seam")
  else
    return("Living Empyrium Seam")
  end
end

function SG3:SG3OnUpdate(frame)
  --While in Legion zones

  local map = C_Map.GetMapInfo(C_Map.GetBestMapForUnit("player"))
  local parent = C_Map.GetMapInfo(map.parentMapID)
  if parent.name == "Broken Isles" or parent.name == "Argus" then

    if GameTooltip:GetOwner() ~= Minimap then
      local ArchyMatch = false
      local SkinningMatch = false
      local Typetext = GameTooltipTextLeft2:GetText()
      if Typetext == nil then
        Typetext = ""
      end
      local text = GameTooltipTextLeft1:GetText()
      local PositiveToolTipMatch = false
      -- Warn about being unable to equip due to combat
      if InCombatLockdown() == true then
        if SG3Skinning == true then
          local Skinningtext = GameTooltipTextLeft3:GetText()
          if Skinningtext == nil then
            Skinningtext = ""
          end
          if string.match(Skinningtext, getglobal("UNIT_SKINNABLE_LEATHER")) then
            if DebugSkinningCombatTimer3Set == false then
              DebugSkinningCombatTimer3Set = true
              self:ScheduleTimer("SkinningWarningTimer", 1)
            end
          end
        end
      end
      if InCombatLockdown() == false then
        if SG3AlreadyCalled == false then
          -- Check for Archaeology
          if SG3Archaelogy == true then
            if text == nil then
              -- Do nothing
            else
              if string.match(text, SG3ArchaelogySurveyString) then
                ArchyMatch = true
                PositiveToolTipMatch = true
              end
            end
          end
          -- Run Through Mining Possible Matches
          if SG3Mining == true then
            if (GetLocale() == "esES") then
              SkinnableRock = "Minería"
            elseif (GetLocale() == "frFR") then
              SkinnableRock = "Minage"
            elseif (GetLocale() == "deDE") then
              SkinnableRock = "Bergbau"
            elseif (GetLocale() == "esMX") then
              SkinnableRock = "Minería"
            elseif (GetLocale() == "ptBR") then
              SkinnableRock = "Mineração"
            elseif (GetLocale() == "ruRU") then
              SkinnableRock = "горного дела"
            else
              SkinnableRock = "Mining"
            end
            if string.match(Typetext, SkinnableRock) then

              --Legion mining nodes
              if string.match(text, SG3:GetFelslateDepositString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetFelslateSeamString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetInfernalBrimstoneString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetLeystoneDepositString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetLeystoneSeamString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetLivingFelslateString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetLivingLeystoneString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetEmpyriumDepositString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetEmpyriumSeamString()) then
                PositiveToolTipMatch = true
              end

            end
          end
          -- Run Through Herbalism Possible Matches
          if SG3Herbalism == true then
            if (GetLocale() == "esES") then
              -- Fix for Blizzard's Typo on GetGlobal
              SkinnableHerb = "Herboristería"
            elseif (GetLocale() == "frFR") then
              SkinnableHerb = "Herboristerie"
            elseif (GetLocale() == "deDE") then
              SkinnableHerb = "Kräuterkunde"
            elseif (GetLocale() == "esMX") then
              SkinnableHerb = "Herboristería"
            elseif (GetLocale() == "ptBR") then
              SkinnableHerb = "Herborismo"
            elseif (GetLocale() == "ruRU") then
              SkinnableHerb = "Травничество"
            else
              SkinnableHerb = "Herbalism"
            end
            if string.match(Typetext, SkinnableHerb) or string.match(Typetext, "Requires Herbalism") then

              -- Legion herbs
              if string.match(text, SG3:GetStarlightRoseHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetAethrilHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetDreamleafHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetFjarnskagglHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetFoxflowerHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetFelEncrustedHerbHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetAstralGloryHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetFelwortHerbString()) then
                PositiveToolTipMatch = true
              end

            end
          end
          -- Run through Skinning Possible Matches
          if SG3Skinning == true then
            local Skinningtext = GameTooltipTextLeft3:GetText()
            if Skinningtext == nil then
              Skinningtext = ""
            end
            if string.match(Skinningtext, getglobal("UNIT_SKINNABLE_LEATHER")) then
              PositiveToolTipMatch = true
              SkinningMatch = true
            end
          end

          if PositiveToolTipMatch == true then
            SG3AlreadyCalled = true
            if GetInventoryItemID("player", 10) == 50984 then
              -- Null
            else
              EquippedGlovesID = GetInventoryItemID("player", 10)
              if GetCVar("Sound_EnableSFX") == "1" then
                ReenableSound = true
                SetCVar("Sound_EnableSFX", 0)
              end
              EquipItemByName(50984)
              if ReenableSound == true then
                SetCVar("Sound_EnableSFX", 1)
                ReenableSound = false
              end
            end
            if ArchyMatch == true then
              self:CancelAllTimers()
              self:ScheduleTimer("ResetTimer", 9)
            else
              self:CancelAllTimers()
              self:ScheduleTimer("ResetTimer", 5)
            end
          end
        else
          if SG3Archaelogy == true then
            if text == nil then
              -- Do nothing
            else
              if string.match(text, SG3ArchaelogySurveyString) then
                ArchyMatch = true
                PositiveToolTipMatch = true
              end
            end
          end

          -- Run Through Mining Possible Matches
          if SG3Mining == true then
            if (GetLocale() == "esES") then
              SkinnableRock = "Minería"
            elseif (GetLocale() == "frFR") then
              SkinnableRock = "Minage"
            elseif (GetLocale() == "deDE") then
              SkinnableRock = "Bergbau"
            elseif (GetLocale() == "esMX") then
              SkinnableRock = "Minería"
            elseif (GetLocale() == "ptBR") then
              SkinnableRock = "Mineração"
            elseif (GetLocale() == "ruRU") then
              SkinnableRock = "горного дела"
            else
              SkinnableRock = "Mining"
            end
            if string.match(Typetext, SkinnableRock) then

              -- Legion mining nodes
              if string.match(text, SG3:GetFelslateDepositString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetFelslateSeamString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetInfernalBrimstoneString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetLeystoneDepositString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetLeystoneSeamString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetLivingFelslateString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetLivingLeystoneString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetEmpyriumDepositString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetEmpyriumSeamString()) then
                PositiveToolTipMatch = true
              end

            end
          end
          -- Run Through Herbalism Possible Matches
          if SG3Herbalism == true then
            if (GetLocale() == "esES") then
              -- Fix for Blizzard's Typo on GetGlobal
              SkinnableHerb = "Herboristería"
            elseif (GetLocale() == "frFR") then
              SkinnableHerb = "Herboristerie"
            elseif (GetLocale() == "deDE") then
              SkinnableHerb = "Kräuterkunde"
            elseif (GetLocale() == "esMX") then
              SkinnableHerb = "Herboristería"
            elseif (GetLocale() == "ptBR") then
              SkinnableHerb = "Herborismo"
            elseif (GetLocale() == "ruRU") then
              SkinnableHerb = "Травничество"
            else
              SkinnableHerb = "Herbalism"
            end
            if string.match(Typetext, SkinnableHerb) or string.match(Typetext, "Requires Herbalism") then

              -- Legion herbs
              if string.match(text, SG3:GetStarlightRoseHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetAethrilHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetDreamleafHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetFjarnskagglHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetFoxflowerHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetFelEncrustedHerbHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetAstralGloryHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG3:GetFelwortHerbString()) then
                PositiveToolTipMatch = true
              end

            end
          end
          -- Run through Skinning Possible Matches
          if SG3Skinning == true then
            local Skinningtext = GameTooltipTextLeft3:GetText()
            if Skinningtext == nil then
              Skinningtext = ""
            end
            if string.match(Skinningtext, getglobal("UNIT_SKINNABLE_LEATHER")) then
              PositiveToolTipMatch = true
              SkinningMatch = true
            end
          end

          if PositiveToolTipMatch == true then
            if ArchyMatch == true then
              self:CancelAllTimers()
              self:ScheduleTimer("ResetTimer", 9)
            elseif SkinningMatch == true then
              self:CancelAllTimers()
              self:ScheduleTimer("ResetTimer", 3)
            else
              self:CancelAllTimers()
              self:ScheduleTimer("ResetTimer", 5)
            end
          end
        end
      end
    end
  end
end

function SG3:ResetTimer()
  if InCombatLockdown() == false then
    SG3AlreadyCalled = false
    if GetCVar("Sound_EnableSFX") == "1" then
      ReenableSound = true
      SetCVar("Sound_EnableSFX", 0)
    end
    EquipItemByName(EquippedGlovesID)
    if ReenableSound == true then
      SetCVar("Sound_EnableSFX", 1)
      ReenableSound = false
    end
  else
    self:ScheduleTimer("ResetTimer", 1)
  end
end

function SG3:SkinningWarningTimer()
  DebugSkinningCombatTimer3Set = false
  print("StickyGloves: Debug Warning, Can Not Equip while In Combat")
end

function SG3:DebugAdd(StringToAdd)
  if SG3DebugString == "Empty" then
    SG3DebugString = "" .. StringToAdd
  else
    SG3DebugString = SG3DebugString .. StringToAdd
  end
  return
end

function SG3:WelcomeTimer()
  -- Main Initialization
  SG3:DebugAdd(GetLocale())

  local RerunTimer = false
  local FirstProfession, SecondProfession, Archy, Fishing, Cooking, FirstAid = GetProfessions("player")

  -- Grab Data for Gloves of Ambivalence
  SG3GlovesName, SG3GlovesItemLink, SG3GlovesRarity, SG3GlovesiLvl, SG3GlovesRequiredLevel, SG3GlovesType, SG3GlovesSubType, SG3GlovesMaxStack, SG3GlovesEquipLocation, SG3GlovesIcon, SG3GlovesVendorSellPrice = GetItemInfo(50984)

  -- SG3GlovesItemLink = "\124cff0070dd\124Hitem:50984:0:0:0:0:0:0:0:0:0:0\124h[Gloves of Ambivalence]\124h\124r"

  if SG3GlovesName == nil then
    self:ScheduleTimer("WelcomeTimer", 3)
    SG3:DebugAdd("Delay on requesting gloves info, Rescheduled Event")
    print("StickyGloves: Can't find " .. SG3GlovesItemLink.. ". Trying again in 3 seconds.")
    RerunTimer = true
    return
  end

  if FirstProfession ~= nil then
    if GetProfessionInfo(FirstProfession) == nil then
      self:ScheduleTimer("WelcomeTimer", 3)
      SG3:DebugAdd("Delay on requesting Profession Details, Rescheduled Event")
      print("StickyGloves: Can't find profession details. Trying again in 3 seconds.")
      RerunTimer = true
    else
      if FirstProfession == nil then
        SG3:DebugAdd("Nill")
      else
        local FirstProfessionName, FirstProfessionIcon, FirstProfessionSkillLevel, FirstProfessionMaxSkill, FirstProfessionAbilities, FirstProfessionOffset, FirstProfessionSkillLine, FirstProfessionSkillModifier = GetProfessionInfo(FirstProfession)
        SG3:DebugAdd(FirstProfessionName)
        SG3:DebugAdd(FirstProfessionSkillLine)
        if FirstProfessionSkillLine == 186 then
          SG3Mining = true
          SG3Disabled = false
        elseif FirstProfessionSkillLine == 182 then
          SG3Herbalism = true
          SG3Disabled = false
        elseif FirstProfessionSkillLine == 393 then
          SG3Skinning = true
          SG3Disabled = false
        end
      end
    end

    if SecondProfession == nil then
      SG3:DebugAdd("Nill")
    else
      local SecondProfessionName, SecondProfessionIcon, SecondProfessionSkillLevel, SecondProfessionMaxSkill, SecondProfessionAbilities, SecondProfessionOffset, SecondProfessionSkillLine, SecondProfessionSkillModifier = GetProfessionInfo(SecondProfession)
      SG3:DebugAdd(SecondProfessionName)
      SG3:DebugAdd(SecondProfessionSkillLine)
      if SecondProfessionSkillLine == 186 then
        SG3Mining = true
        SG3Disabled = false
      elseif SecondProfessionSkillLine == 182 then
        SG3Herbalism = true
        SG3Disabled = false
      elseif SecondProfessionSkillLine == 393 then
        SG3Skinning = true
        SG3Disabled = false
      end
    end

    if Archy == nil then
      SG3Archaelogy = false
    else
      local ArchyName, ArchyRank, ArchyIcon, ArchyCost, ArchyMinRange, ArchyMaxRange = GetSpellInfo(80451)
      SG3ArchaelogySurveyString = ArchyName
      SG3Archaelogy = true
      SG3Disabled = false
    end
  else
    print("StickyGloves: Disabled due to No Professions on Character.")
    SG3Disabled = true
    SG3:DebugAdd("Disabled due to 0 Professions")
  end

  if RerunTimer == false then
    if UnitLevel("player") < 10 then
      SG3Disabled = true
      SG3:DebugAdd("Disabled due to current character being under Level 10.")
    end
    SG3:DebugAdd(UnitName("player"))

    -- Check Bags for Gloves
    for bag = 0, 4 do
      for slot = 1, GetContainerNumSlots(bag) do
        local item = GetContainerItemLink(bag, slot)
        if item and item:find(SG3GlovesName) then
          SG3HasGloves = true
        end
      end
    end

    if SG3HasGloves == false then
      SG3:DebugAdd("No Gloves")
      SG3Disabled = true
      if SG3FirstRun == true then
        print("SG: " .. SG3GlovesItemLink.. " could not be found in your bags.")
      end
    end

    if SG3Disabled == false then
      SG3:DebugAdd("All Good")
      self:HookScript(GameTooltip, "OnUpdate", "SG3OnUpdate")
      print("SG: Swapping " .. SG3GlovesItemLink .. " in Legion zones.")
    end
  end
end
