SG = LibStub("AceAddon-3.0"):NewAddon("SG", "AceHook-3.0", "AceTimer-3.0")

-- Forager's Gloves in Pandaria

local SGAlreadyCalled = false
local EquippedGlovesID = 1
local SGDisabled = true
local SGMining = false
local SGSkinning = false
local SGHerbalism = false
local SGHasGloves = false
local SGArchaelogy = false
local SGArchaelogySurveyString = ""
local DebugSkinningCombatTimerSet = false

SGDebugString = "Empty"

-- ~ Initial Release
local SGframe = CreateFrame("FRAME");
SGframe:RegisterEvent("PLAYER_LOGOUT");
SGframe:RegisterEvent("ADDON_LOADED");

function SGframe:OnEvent(event, arg)
  if event == "ADDON_LOADED" and arg == "StickyGloves" then
    print("StickyGloves loaded: Pandaria")
    if SGFirstRun == nil then
      SGFirstRun = true;
    end
  elseif event == "PLAYER_LOGOUT" then
    SGFirstRun = false;
  end
end

SGframe:SetScript("OnEvent", SGframe.OnEvent);

function SG:OnEnable()
  self:ScheduleTimer("WelcomeTimer", 3)
end

-- Local Translations for Objects not available through internal lookups

-- Pandaria mining nodes
function SG:GetGhostIronDepositString()
  if (GetLocale() == "enUS") then
    return("Ghost Iron Deposit")
  else
    return("Ghost Iron Deposit")
  end
end
function SG:GetRichGhostIronDepositString()
  if (GetLocale() == "enUS") then
    return("Rich Ghost Iron Deposit")
  else
    return("Rich Ghost Iron Deposit")
  end
end
function SG:GetTrilliumVeinString()
  if (GetLocale() == "enUS") then
    return("Trillium Vein")
  else
    return("Trillium Vein")
  end
end
function SG:GetRichTrilliumVeinString()
  if (GetLocale() == "enUS") then
    return("Rich Trillium Vein")
  else
    return("Rich Trillium Vein")
  end
end
function SG:GetKypariteDepositString()
  if (GetLocale() == "enUS") then
    return("Kyparite Deposit")
  else
    return("Kyparite Deposit")
  end
end
function SG:GetRichKypariteDepositString()
  if (GetLocale() == "enUS") then
    return("Rich Kyparite Deposit")
  else
    return("Rich Kyparite Deposit")
  end
end

-- Pandaria herb nodes
function SG:GetFoolsCapHerbString()
  if (GetLocale() == "enUS") then
    return("Fool's Cap")
  else
    return("Fool's Cap")
  end
end
function SG:GetGoldenLotusHerbString()
  if (GetLocale() == "enUS") then
    return("Golden Lotus")
  else
    return("Golden Lotus")
  end
end
function SG:GetGreenTeaLeafHerbString()
  if (GetLocale() == "enUS") then
    return("Green Tea Leaf")
  else
    return("Green Tea Leaf")
  end
end
function SG:GetRainPoppyHerbString()
  if (GetLocale() == "enUS") then
    return("Rain Poppy")
  else
    return("Rain Poppy")
  end
end
function SG:GetShaTouchedHerbString()
  if (GetLocale() == "enUS") then
    return("Sha-Touched Herb")
  else
    return("Sha-Touched Herb")
  end
end
function SG:GetSilkweedString()
  if (GetLocale() == "enUS") then
    return("Silkweed")
  else
    return("Silkweed")
  end
end
function SG:GetSnowLillyHerbString()
  if (GetLocale() == "enUS") then
    return("Snow Lily")
  else
    return("Snow Lily")
  end
end

function SG:SGOnUpdate(frame)
  --While in Pandaria zones

  local map = C_Map.GetMapInfo(C_Map.GetBestMapForUnit("player"))
  local parent = C_Map.GetMapInfo(map.parentMapID)
  if parent.name == "Pandaria" or parent.name == "Timeless Isle" or parent.name == "Isle of Thunder" then

    if GameTooltip:GetOwner() ~= Minimap then
      local ArchyMatch = false
      local SkinningMatch = false
      local Typetext = GameTooltipTextLeft2:GetText()
      if Typetext == nil then
        Typetext = ""
      end
      local text = GameTooltipTextLeft1:GetText()
      local PositiveToolTipMatch = false
      -- Warn about being unable to equip due to combat
      if InCombatLockdown() == true then
        if SGSkinning == true then
          local Skinningtext = GameTooltipTextLeft3:GetText()
          if Skinningtext == nil then
            Skinningtext = ""
          end
          if string.match(Skinningtext, getglobal("UNIT_SKINNABLE_LEATHER")) then
            if DebugSkinningCombatTimerSet == false then
              DebugSkinningCombatTimerSet = true
              self:ScheduleTimer("SkinningWarningTimer", 1)
            end
          end
        end
      end
      if InCombatLockdown() == false then
        if SGAlreadyCalled == false then
          -- Check for Archaeology
          if SGArchaelogy == true then
            if text == nil then
              -- Do nothing
            else
              if string.match(text, SGArchaelogySurveyString) then
                ArchyMatch = true
                PositiveToolTipMatch = true
              end
            end
          end

          -- Run Through Mining Possible Matches
          if SGMining == true then
            if (GetLocale() == "esES") then
              SkinnableRock = "Minería"
            elseif (GetLocale() == "frFR") then
              SkinnableRock = "Minage"
            elseif (GetLocale() == "deDE") then
              SkinnableRock = "Bergbau"
            elseif (GetLocale() == "esMX") then
              SkinnableRock = "Minería"
            elseif (GetLocale() == "ptBR") then
              SkinnableRock = "Mineração"
            elseif (GetLocale() == "ruRU") then
              SkinnableRock = "горного дела"
            else
              SkinnableRock = "Mining"
            end
            if string.match(Typetext, SkinnableRock) then

              -- Pandaria mining nodes
              if string.match(text, SG:GetGhostIronDepositString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetRichGhostIronDepositString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetTrilliumVeinString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetRichTrilliumVeinString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetKypariteDepositString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetRichKypariteDepositString()) then
                PositiveToolTipMatch = true
              end

            end
          end
          -- Run Through Herbalism Possible Matches
          if SGHerbalism == true then
            if (GetLocale() == "esES") then
              -- Fix for Blizzard's Typo on GetGlobal
              SkinnableHerb = "Herboristería"
            elseif (GetLocale() == "frFR") then
              SkinnableHerb = "Herboristerie"
            elseif (GetLocale() == "deDE") then
              SkinnableHerb = "Kräuterkunde"
            elseif (GetLocale() == "esMX") then
              SkinnableHerb = "Herboristería"
            elseif (GetLocale() == "ptBR") then
              SkinnableHerb = "Herborismo"
            elseif (GetLocale() == "ruRU") then
              SkinnableHerb = "Травничество"
            else
              SkinnableHerb = "Herbalism"
            end
            if string.match(Typetext, SkinnableHerb) or string.match(Typetext, "Requires Herbalism") then

              -- Pandaria herbs
              if string.match(text, SG:GetFoolsCapHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetGoldenLotusHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetGreenTeaLeafHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetRainPoppyHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetShaTouchedHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetSilkweedString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetSnowLillyHerbString()) then
                PositiveToolTipMatch = true
              end

            end
          end
          -- Run through Skinning Possible Matches
          if SGSkinning == true then
            local Skinningtext = GameTooltipTextLeft3:GetText()
            if Skinningtext == nil then
              Skinningtext = ""
            end
            if string.match(Skinningtext, getglobal("UNIT_SKINNABLE_LEATHER")) then
              PositiveToolTipMatch = true
              SkinningMatch = true
            end
          end

          if PositiveToolTipMatch == true then
            SGAlreadyCalled = true
            if GetInventoryItemID("player", 10) == 86566 then
              -- Null
            else
              EquippedGlovesID = GetInventoryItemID("player", 10)
              if GetCVar("Sound_EnableSFX") == "1" then
                ReenableSound = true
                SetCVar("Sound_EnableSFX", 0)
              end
              EquipItemByName(86566)
              if ReenableSound == true then
                SetCVar("Sound_EnableSFX", 1)
                ReenableSound = false
              end
            end
            if ArchyMatch == true then
              self:CancelAllTimers()
              self:ScheduleTimer("ResetTimer", 9)
            else
              self:CancelAllTimers()
              self:ScheduleTimer("ResetTimer", 5)
            end
          end
        else
          if SGArchaelogy == true then
            if text == nil then
              -- Do nothing
            else
              if string.match(text, SGArchaelogySurveyString) then
                ArchyMatch = true
                PositiveToolTipMatch = true
              end
            end
          end

          -- Run Through Mining Possible Matches
          if SGMining == true then
            if (GetLocale() == "esES") then
              SkinnableRock = "Minería"
            elseif (GetLocale() == "frFR") then
              SkinnableRock = "Minage"
            elseif (GetLocale() == "deDE") then
              SkinnableRock = "Bergbau"
            elseif (GetLocale() == "esMX") then
              SkinnableRock = "Minería"
            elseif (GetLocale() == "ptBR") then
              SkinnableRock = "Mineração"
            elseif (GetLocale() == "ruRU") then
              SkinnableRock = "горного дела"
            else
              SkinnableRock = "Mining"
            end
            if string.match(Typetext, SkinnableRock) then

              -- Pandaria mining
              if string.match(text, SG:GetGhostIronDepositString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetRichGhostIronDepositString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetTrilliumVeinString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetRichTrilliumVeinString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetKypariteDepositString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetRichKypariteDepositString()) then
                PositiveToolTipMatch = true
              end

            end
          end
          -- Run Through Herbalism Possible Matches
          if SGHerbalism == true then
            if (GetLocale() == "esES") then
              -- Fix for Blizzard's Typo on GetGlobal
              SkinnableHerb = "Herboristería"
            elseif (GetLocale() == "frFR") then
              SkinnableHerb = "Herboristerie"
            elseif (GetLocale() == "deDE") then
              SkinnableHerb = "Kräuterkunde"
            elseif (GetLocale() == "esMX") then
              SkinnableHerb = "Herboristería"
            elseif (GetLocale() == "ptBR") then
              SkinnableHerb = "Herborismo"
            elseif (GetLocale() == "ruRU") then
              SkinnableHerb = "Травничество"
            else
              SkinnableHerb = "Herbalism"
            end
            if string.match(Typetext, SkinnableHerb) or string.match(Typetext, "Requires Herbalism") then

              -- Pandaria herbs
              if string.match(text, SG:GetFoolsCapHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetGoldenLotusHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetGreenTeaLeafHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetRainPoppyHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetShaTouchedHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetSilkweedString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG:GetSnowLillyHerbString()) then
                PositiveToolTipMatch = true
              end

            end
          end
          -- Run through Skinning Possible Matches
          if SGSkinning == true then
            local Skinningtext = GameTooltipTextLeft3:GetText()
            if Skinningtext == nil then
              Skinningtext = ""
            end
            if string.match(Skinningtext, getglobal("UNIT_SKINNABLE_LEATHER")) then
              PositiveToolTipMatch = true
              SkinningMatch = true
            end
          end

          if PositiveToolTipMatch == true then
            if ArchyMatch == true then
              self:CancelAllTimers()
              self:ScheduleTimer("ResetTimer", 9)
            elseif SkinningMatch == true then
              self:CancelAllTimers()
              self:ScheduleTimer("ResetTimer", 3)
            else
              self:CancelAllTimers()
              self:ScheduleTimer("ResetTimer", 5)
            end
          end
        end
      end
    end
  end
end

function SG:ResetTimer()
  if InCombatLockdown() == false then
    SGAlreadyCalled = false
    if GetCVar("Sound_EnableSFX") == "1" then
      ReenableSound = true
      SetCVar("Sound_EnableSFX", 0)
    end
    EquipItemByName(EquippedGlovesID)
    if ReenableSound == true then
      SetCVar("Sound_EnableSFX", 1)
      ReenableSound = false
    end
  else
    self:ScheduleTimer("ResetTimer", 1)
  end
end

function SG:SkinningWarningTimer()
  DebugSkinningCombatTimerSet = false
  print("StickyGloves: Debug Warning, Can Not Equip while In Combat")
end

function SG:DebugAdd(StringToAdd)
  if SGDebugString == "Empty" then
    SGDebugString = "" .. StringToAdd
  else
    SGDebugString = SGDebugString .. StringToAdd
  end
  return
end

function SG:WelcomeTimer()
  -- Main Initialization
  SG:DebugAdd(GetLocale())

  local RerunTimer = false
  local FirstProfession, SecondProfession, Archy, Fishing, Cooking, FirstAid = GetProfessions("player")

  -- Grab Data for Foragers Gloves
  ForagersGlovesName, ForagersGlovesItemLink, ForagersGlovesRarity, ForagersGlovesiLvl, ForagersGlovesRequiredLevel, ForagersGlovesType, ForagersGlovesSubType, ForagersGlovesMaxStack, ForagersGlovesEquipLocation, ForagersGlovesIcon, ForagersGlovesVendorSellPrice = GetItemInfo(86566)

  -- ForagersGlovesItemLink = "\124cff0070dd\124Hitem:86566:0:0:0:0:0:0:0:0:0:0\124h[Forager's Gloves]\124h\124r"

  if ForagersGlovesName == nil then
    self:ScheduleTimer("WelcomeTimer", 3)
    SG:DebugAdd("Delay on requesting gloves info, Rescheduled Event")
    print("StickyGloves: Can't find " .. ForagersGlovesItemLink.. ". Trying again in 3 seconds.")
    RerunTimer = true
    return
  end

  if FirstProfession ~= nil then
    if GetProfessionInfo(FirstProfession) == nil then
      self:ScheduleTimer("WelcomeTimer", 3)
      SG:DebugAdd("Delay on requesting Profession Details, Rescheduled Event")
      print("StickyGloves: Can't find profession details. Trying again in 3 seconds.")
      RerunTimer = true
    else
      if FirstProfession == nil then
        SG:DebugAdd("Nill")
      else
        local FirstProfessionName, FirstProfessionIcon, FirstProfessionSkillLevel, FirstProfessionMaxSkill, FirstProfessionAbilities, FirstProfessionOffset, FirstProfessionSkillLine, FirstProfessionSkillModifier = GetProfessionInfo(FirstProfession)
        SG:DebugAdd(FirstProfessionName)
        SG:DebugAdd(FirstProfessionSkillLine)
        if FirstProfessionSkillLine == 186 then
          SGMining = true
          SGDisabled = false
        elseif FirstProfessionSkillLine == 182 then
          SGHerbalism = true
          SGDisabled = false
        elseif FirstProfessionSkillLine == 393 then
          SGSkinning = true
          SGDisabled = false
        end
      end
    end

    if SecondProfession == nil then
      SG:DebugAdd("Nill")
    else
      local SecondProfessionName, SecondProfessionIcon, SecondProfessionSkillLevel, SecondProfessionMaxSkill, SecondProfessionAbilities, SecondProfessionOffset, SecondProfessionSkillLine, SecondProfessionSkillModifier = GetProfessionInfo(SecondProfession)
      SG:DebugAdd(SecondProfessionName)
      SG:DebugAdd(SecondProfessionSkillLine)
      if SecondProfessionSkillLine == 186 then
        SGMining = true
        SGDisabled = false
      elseif SecondProfessionSkillLine == 182 then
        SGHerbalism = true
        SGDisabled = false
      elseif SecondProfessionSkillLine == 393 then
        SGSkinning = true
        SGDisabled = false
      end
    end

    if Archy == nil then
      SGArchaelogy = false
    else
      local ArchyName, ArchyRank, ArchyIcon, ArchyCost, ArchyMinRange, ArchyMaxRange = GetSpellInfo(80451)
      SGArchaelogySurveyString = ArchyName
      SGArchaelogy = true
      SGDisabled = false
    end
  else
    print("StickyGloves: Disabled due to No Professions on Character.")
    SGDisabled = true
    SG:DebugAdd("Disabled due to 0 Professions")
  end

  if RerunTimer == false then
    if UnitLevel("player") < 10 then
      SGDisabled = true
      SG:DebugAdd("Disabled due to current character being under Level 10.")
    end
    SG:DebugAdd(UnitName("player"))

    -- Check Bags for Gloves
    for bag = 0, 4 do
      for slot = 1, GetContainerNumSlots(bag) do
        local item = GetContainerItemLink(bag, slot)
        if item and item:find(ForagersGlovesName) then
          SGHasGloves = true
        end
      end
    end

    if SGHasGloves == false then
      SG:DebugAdd("No Gloves")
      SGDisabled = true
      if SGFirstRun == true then
        print("SG: " .. ForagersGlovesItemLink.. " could not be found in your bags.")
      end
    end

    if SGDisabled == false then
      SG:DebugAdd("All Good")
      self:HookScript(GameTooltip, "OnUpdate", "SGOnUpdate")
      print("SG: Swapping " .. ForagersGlovesItemLink .. " in Pandaria zones.")
    end
  end
end
